module Basil
  module Barcodes

    # return a directory with the project libraries
    def self.gem_libdir
      File.dirname(__FILE__)
    end

    # list available barcodes files
    def self.barcode_files
      Dir[File.join(self.gem_libdir, 'barcodes', '*.csv')]
    end

    def self.barcodes
      self.barcode_files.map { |x| File.basename(x, File.extname(x)) }
    end

    # returns true if string matches a file in the barcodes directory
    def self.has_barcode?(string)
      self.barcodes.include? File.basename(string, File.extname(string))
    end

    # return path for barcode file given a string
    def self.barcode_path(string)
      self.barcode_files.reject { |x| File.basename(x, File.extname(x)) != string }.first rescue nil
    end

  end
end

